Index: trunk/Poubelle/archTOI.old/toillreglageproducer.cc
===================================================================
--- trunk/Poubelle/archTOI.old/toillreglageproducer.cc	(revision 534)
+++ trunk/Poubelle/archTOI.old/toillreglageproducer.cc	(revision 534)
@@ -0,0 +1,128 @@
+// toillreglageproducer.cc
+// Eric Aubourg         CEA/DAPNIA/SPP   septembre 1999
+
+#include "toillreglageproducer.h"
+#include "archfileset.h"
+#include "toimanager.h"
+#include "requesthandler.h"
+
+// horloge
+#define horlPeriode    "horlPeriode"
+#define horlNbMesures  "horlNbMesures"
+#define horlTempMort   "horlTempMort"
+#define horlFlag       "horlFlag"
+
+// regul_bolo
+#define regMode        "regMode"         // index regul 
+#define regNumBolo     "regNumBolo"
+#define regVoieChauf   "regVoieChauf"
+#define regProp        "regProp"
+#define regInteg       "regInteg"
+#define regDeriv       "regDeriv"
+#define regChauffage   "regChauffage"
+
+// auto_bolo
+#define autoBolMode    "autoBolMode"     // index voie
+#define autoBolGain    "autoBolGain"
+#define autoBolCourant "autoBolCourant"
+#define autoBolDelai   "autoBolDelai"
+
+// auto_dilu
+#define autoDilVanne   "autoDilVanne"
+#define autoDilHelium  "autoDilHelium"
+#define autoDilChauff  "autoDilChauff"
+#define autoDilPiles   "autoDilPiles"
+#define autoDilTrans   "autoDilTrans"
+#define autoDilTMxVan  "autoDilTMxVan"
+#define autoDilxx7     "autoDilxx7"
+#define autoDilxx8     "autoDilxx8"
+
+// reglage_un_bolo
+#define boloDACV       "boloDACV"       // index bolo
+#define boloDACI       "boloDACI"
+
+
+TOILLReglageProducer::TOILLReglageProducer()
+{
+  possibleTOIs.insert(TOI(horlPeriode,   TOI::unspec, "", "CHAR-CODED"));  
+  possibleTOIs.insert(TOI(horlNbMesures, TOI::unspec, "", "CHAR-CODED"));  
+  possibleTOIs.insert(TOI(horlTempMort,  TOI::unspec, "", "CHAR-CODED"));  
+  possibleTOIs.insert(TOI(horlFlag,      TOI::unspec, "", "CHAR-CODED"));  
+  
+  possibleTOIs.insert(TOI(regMode,       TOI::all,    "", "CHAR-CODED"));  
+  possibleTOIs.insert(TOI(regNumBolo,    TOI::all,    "", "CHAR-CODED"));  
+  possibleTOIs.insert(TOI(regVoieChauf,  TOI::all,    "", "CHAR-CODED"));  
+  possibleTOIs.insert(TOI(regProp,       TOI::all,    "", "CHAR-CODED"));  
+  possibleTOIs.insert(TOI(regInteg,      TOI::all,    "", "CHAR-CODED"));  
+  possibleTOIs.insert(TOI(regDeriv,      TOI::all,    "", "CHAR-CODED"));  
+  possibleTOIs.insert(TOI(regChauffage,  TOI::all,    "", "CHAR-CODED"));  
+
+  possibleTOIs.insert(TOI(autoBolMode,   TOI::all,    "", "CHAR-CODED"));  
+  possibleTOIs.insert(TOI(autoBolGain,   TOI::all,    "", "CHAR-CODED"));  
+  possibleTOIs.insert(TOI(autoBolCourant,TOI::all,    "", "CHAR-CODED"));  
+  possibleTOIs.insert(TOI(autoBolDelai,  TOI::all,    "", "CHAR-CODED"));  
+
+  possibleTOIs.insert(TOI(autoDilVanne,  TOI::unspec, "", "CHAR-CODED"));  
+  possibleTOIs.insert(TOI(autoDilHelium, TOI::unspec, "", "CHAR-CODED"));  
+  possibleTOIs.insert(TOI(autoDilChauff, TOI::unspec, "", "CHAR-CODED"));  
+  possibleTOIs.insert(TOI(autoDilPiles,  TOI::unspec, "", "CHAR-CODED"));  
+  possibleTOIs.insert(TOI(autoDilTrans,  TOI::unspec, "", "CHAR-CODED"));  
+  possibleTOIs.insert(TOI(autoDilTMxVan, TOI::unspec, "", "CHAR-CODED"));  
+  possibleTOIs.insert(TOI(autoDilxx7,    TOI::unspec, "", "CHAR-CODED"));  
+  possibleTOIs.insert(TOI(autoDilxx8,    TOI::unspec, "", "CHAR-CODED"));  
+  
+  possibleTOIs.insert(TOI(boloDACV,      TOI::all,    "", "microVolts"));  
+  possibleTOIs.insert(TOI(boloDACI,      TOI::all,    "", "microAmps"));  
+}
+
+string TOILLReglageProducer::getName() {
+  return("TOILLReglageProducer 1.0");
+}
+
+
+
+#define COMPTOI(_toi_, _field_)                               \
+    if ((*i).name == _toi_) {                                 \
+      computedValue((*i),sample0, blk->reglage._field_);      \
+    }
+
+void TOILLReglageProducer::handleBlock(ArchFileSet* fs)
+{
+  block_type_reglage* blk = fs->lastReglage();
+  long sample0 = numero_block(blk)*72;
+  for (set<TOI>::iterator i = producedTOIs.begin(); i != producedTOIs.end(); i++) {
+    int k = (*i).index;
+    COMPTOI(horlPeriode,    horloge.periode) else
+    COMPTOI(horlNbMesures,  horloge.nb_mesures) else
+    COMPTOI(horlTempMort,   horloge.temp_mort) else
+    COMPTOI(horlFlag,       horloge.flag) else
+    COMPTOI(regMode,        regul[k].mode) else
+    COMPTOI(regNumBolo,     regul[k].num_bolo) else
+    COMPTOI(regVoieChauf,   regul[k].voie_chauf) else
+    COMPTOI(regProp,        regul[k].prop) else
+    COMPTOI(regInteg,       regul[k].integ) else
+    COMPTOI(regDeriv,       regul[k].deriv) else
+    COMPTOI(regChauffage,   regul[k].chauffage) else
+    COMPTOI(autoBolMode,    autom[k].mode) else
+    COMPTOI(autoBolGain,    autom[k].gain) else
+    COMPTOI(autoBolCourant, autom[k].courant) else
+    COMPTOI(autoBolDelai,   autom[k].delai) else
+    COMPTOI(autoDilVanne,   dilu.vanne) else
+    COMPTOI(autoDilHelium,  dilu.helium) else
+    COMPTOI(autoDilChauff,  dilu.chauffage) else
+    COMPTOI(autoDilPiles,   dilu.piles) else
+    COMPTOI(autoDilTrans,   dilu.transmission) else
+    COMPTOI(autoDilTMxVan,  dilu.temps_max_vanne) else
+    COMPTOI(autoDilxx7,     dilu.xx7) else
+    COMPTOI(autoDilxx8,     dilu.xx8) else
+    if ((*i).name == boloDACV) {
+      computedValue((*i), sample0, DAC_muV(&fs->lastParam()->param, &blk->reglage, k));
+    } else
+    if ((*i).name == boloDACI) {
+      computedValue((*i), sample0, DAC_muA(&fs->lastParam()->param, &blk->reglage, k));
+    }
+  }
+}
+
+
+
Index: trunk/Poubelle/archTOI.old/toillreglageproducer.h
===================================================================
--- trunk/Poubelle/archTOI.old/toillreglageproducer.h	(revision 534)
+++ trunk/Poubelle/archTOI.old/toillreglageproducer.h	(revision 534)
@@ -0,0 +1,23 @@
+// toillreglageproducer.h
+// Eric Aubourg         CEA/DAPNIA/SPP   septembre 1999
+
+#ifndef TOILLREGLAGEPRODUCER_H
+#define TOILLREGLAGEPRODUCER_H
+
+#include "toiproducer.h"
+#include "ark.h"
+
+
+class TOILLReglageProducer : public TOILowLevProducer {
+public:
+  TOILLReglageProducer();
+  void handleBlock(ArchFileSet*); // push !
+  virtual string getName();
+
+};
+
+
+
+
+
+#endif
Index: trunk/Poubelle/archTOI.old/toillsstproducer.cc
===================================================================
--- trunk/Poubelle/archTOI.old/toillsstproducer.cc	(revision 534)
+++ trunk/Poubelle/archTOI.old/toillsstproducer.cc	(revision 534)
@@ -0,0 +1,110 @@
+// toillsstproducer.cc
+// Eric Aubourg         CEA/DAPNIA/SPP   octobre 1999
+
+#include "toillsstproducer.h"
+#include "archfileset.h"
+#include "toimanager.h"
+#include "requesthandler.h"
+
+#define sstChannel    "sstChannel"
+#define sstChannelCN  "sstChannelCN"
+#define sstDiode      "sstDiode"
+#define sstDiodeCN    "sstDiodeCN"
+
+// diodpermut[i] = channel de la diode i
+int TOILLSSTProducer::diodpermut[46]=
+ { 8,24,40, 9,25,41,10,26,42,11,
+  27,43,16,32, 1,17,33, 2,18,34,
+   3,19,35,12,28,44,13,29,45,14,
+  30,46,15,31,47,20,36, 5,21,37,
+   6,22,38, 7,23,39};
+ // voies 0 et 4 non connectees, voie 1 en panne.
+
+
+TOILLSSTProducer::TOILLSSTProducer()
+{
+  possibleTOIs.insert(TOI(sstChannel,       TOI::all, "", "ADU"));  
+  possibleTOIs.insert(TOI(sstChannelCN,     TOI::all, "", "ADU"));
+  possibleTOIs.insert(TOI(sstDiode,         TOI::all, "", "ADU"));  
+  possibleTOIs.insert(TOI(sstDiodeCN,       TOI::all, "", "ADU"));
+}
+
+string TOILLSSTProducer::getName() {
+  return("TOILLSSTProducer 1.0");
+}
+
+
+void TOILLSSTProducer::registerProcessor(SSTDataProcessor* p) {
+  processors.push_back(p);
+}
+
+void TOILLSSTProducer::DecodeTMBlock(block_type_sst* blk, int i, int* diod)
+{
+  int j; // 0-5 : numero du bloc de 8 diodes
+  int k; // 0-2 : indice du bloc de 4 bits (une diode = 12 bits = 3 blocs de 4 bits)
+  int l; // 0-7 : indice de la diode dans son bloc (8 diodes * 4 bits = 1 mot de 32 bits)
+  
+  // numero de la diode (0-47) = j*8+l;
+  // indice dans le bloc sst du mot de 32 bits (0-17) = j*3+k;
+  // indice dans mot de 32 bits du premier bit utile = 4*l;
+    
+  for (j=0; j<48; j++) diod[j] = 0;
+  
+  for (j=0; j<6; j++)
+    for (k=0; k<3; k++)
+      for (l=0; l<8; l++) {
+        int4 word = blk->sst[i][j*3+k];
+        word = (word >> (4*l)) & 0xF;
+        diod[j*8+l] = (diod[j*8+l] << 4) + word;
+      }
+
+  for (j=0; j<48; j++)  diod[j] -= 2048;
+}
+
+double TOILLSSTProducer::getSSTRawSignalCN(ArchFileSet* fs, int ichannel, int imesure) {
+  // Si pas bloc comprime -> 0.5
+  if (fs->lastSSTComp() == NULL) return .5;
+  if (numero_block(fs->lastSSTComp()) != numero_block(fs->lastSST())) return 0.5;
+  
+  // Attention, on ne transmet pas les canaux 0 et 4....
+  if (ichannel == 0 || ichannel == 4) return 0;
+  int i = ichannel - 1;
+  if (i >= 4) i--;
+  unsigned int4* data = fs->lastSSTComp()->sst[i];
+  // Les deux premieres valeurs sont codees directement...
+  if (imesure<2) return 0.5;
+  int iExp = (imesure-2)/7 + 1;
+  int expo = data[iExp] & 0xf;
+  int noise = 1 << expo;
+  return noise/2.;
+}
+
+void TOILLSSTProducer::handleBlock(ArchFileSet* fs)
+{
+  block_type_sst* blk = fs->lastSST();
+  long sample0 = numero_block(blk)*72;
+  int channels[48];
+  int diodes[46];
+  for (int j=0; j<nb_per_block*2; j++) {
+    DecodeTMBlock(blk, j, channels);
+    for (int i=0; i<46; i++)
+      diodes[i] = channels[diodpermut[i]];
+    for (vector<SSTDataProcessor*>::iterator i = processors.begin(); 
+         i != processors.end(); i++) {
+      (*i)->dataFeed(sample0 + j, diodes);    
+    }
+    for (set<TOI>::iterator i = producedTOIs.begin(); i != producedTOIs.end(); i++) {
+      int ich = (*i).index;
+      if ((*i).name == sstChannel) {
+        computedValue((*i), sample0+j, channels[ich]);
+      } else if ((*i).name == sstDiode) {
+        computedValue((*i), sample0+j, diodes[ich]);
+      } else if ((*i).name == sstChannelCN) {
+        computedValue((*i), sample0+j, getSSTRawSignalCN(fs, ich, j));
+      } else if ((*i).name == sstDiodeCN) {
+        computedValue((*i), sample0+j, getSSTRawSignalCN(fs, diodpermut[ich], j));
+      }
+    }
+  }
+}
+
Index: trunk/Poubelle/archTOI.old/toillsstproducer.h
===================================================================
--- trunk/Poubelle/archTOI.old/toillsstproducer.h	(revision 534)
+++ trunk/Poubelle/archTOI.old/toillsstproducer.h	(revision 534)
@@ -0,0 +1,35 @@
+// toillsstproducer.h
+// Eric Aubourg         CEA/DAPNIA/SPP   octobre 1999
+
+#ifndef TOILLSSTPRODUCER_H
+#define TOILLSSTPRODUCER_H
+
+#include "toiproducer.h"
+#include "ark.h"
+
+class SSTDataProcessor {
+public:
+   virtual void dataFeed(long sampleNum, int* diodeSignal)=0; // signal for 46 diodes...
+};
+
+class TOILLSSTProducer : public TOILowLevProducer {
+public:
+  TOILLSSTProducer();
+  void handleBlock(ArchFileSet*); // push !
+  
+  void registerProcessor(SSTDataProcessor*);
+  virtual string getName();
+
+protected:
+  static int  diodpermut[46]; // diodpermut[i] = channel de la diode i
+  vector<SSTDataProcessor*> processors;
+  
+  void DecodeTMBlock(block_type_sst* blk, int i, int* diod);
+  double getSSTRawSignalCN(ArchFileSet* fs, int ichannel, int imesure);
+};
+
+
+
+
+
+#endif
Index: trunk/Poubelle/archTOI.old/toimanager.cc
===================================================================
--- trunk/Poubelle/archTOI.old/toimanager.cc	(revision 534)
+++ trunk/Poubelle/archTOI.old/toimanager.cc	(revision 534)
@@ -0,0 +1,102 @@
+// toimanager.cc
+// Eric Aubourg         CEA/DAPNIA/SPP   septembre 1999
+
+#include "toimanager.h"
+#include "archexc.h"
+#include "toiproducer.h"
+//#include "toiabsorber.h"
+
+
+void TOIManager::registerProducer(TOIProducer* p) {
+  producers.insert(p);
+}
+
+TOIProducer* TOIManager::findTOIProducer(TOI const& toi) {
+  TOIProducer* p = NULL;
+  for (set<TOIProducer*>::iterator i=producers.begin();
+       i != producers.end(); i++) {
+    if ((*i)->canProduce(toi)) {
+      if (p) throw ArchExc("Duplicate producers for toi" + toi.name);
+      p = *i;
+    }    
+  }
+  if (!p) return NULL; // no producer for this TOI
+//  p->addTOI(toi, client);
+  return p;
+}
+
+set<TOIProducer*> TOIManager::producers;
+map<TOILowLevProducer*, long> TOIManager::llProducers;
+map<TOILowLevProducer*, long> TOIManager::activeLLProducers;
+int TOIManager::trigMask = 0;
+
+void TOIManager::registerLLProducer(TOILowLevProducer* p, int blk_mask) {
+  registerProducer(p);
+  //trigMask |= blk_mask;
+  llProducers[p] = blk_mask;
+}
+
+void TOIManager::activateLLProducer(TOILowLevProducer* p) {
+  //registerProducer(p);
+  int blk_mask = llProducers[p];
+  trigMask |= blk_mask;
+  activeLLProducers[p] = blk_mask;
+}
+
+
+void TOIManager::dumpAvailTOIs(ostream& s) {
+ s << "*** Available TOIs\n";
+ for (set<TOIProducer*>::iterator i = producers.begin(); i != producers.end(); i++) {
+   TOIProducer* prod = *i;
+   set<TOI> x = prod->getPossibleTOIs();
+   for (set<TOI>::iterator j = x.begin(); j != x.end(); j++) {
+     TOI toi = *j;
+     cout << toi.name;
+     if (toi.index == TOI::all) cout << " * ";
+     for (set<string>::iterator k = toi.options.begin(); k != toi.options.end(); k++) {
+       cout << " ";
+       if (toi.reqOptions.find(*k) != toi.reqOptions.end()) cout << "+";
+       cout << *k;
+     }
+     cout << "\n";
+   }
+ }
+
+}
+
+
+
+#include "archeopsfile.h"
+
+#include "toillboloproducer.h"
+#include "toillreglageproducer.h"
+#include "toilldiluproducer.h"
+#include "toillgpsproducer.h"
+#include "toillgyroproducer.h"
+#include "toillsstproducer.h"
+
+#include "timetoiproducer.h"
+#include "toiboloproducer.h"
+#include "sststarfinder.h"
+#include "tsidproducer.h"
+#include "galcrosslocator.h"
+#include "starmatcher.h"
+
+void TOIManager::registerDefaultProducers() {
+  REGLLPROD(TOILLBoloProducer,    block_bolo_mask);
+  REGLLPROD(TOILLReglageProducer, block_reglage_mask);
+  REGLLPROD(TOILLDiluProducer,    block_dilution_mask);
+  REGLLPROD(TOILLGPSProducer,     block_gps_mask);
+  REGLLPROD(TOILLGyroProducer,    block_gyro_mask);
+  REGLLPROD(TOILLSSTProducer,     block_sst_mask);
+  
+  REGPROD(TimeTOIProducer);
+  REGPROD(TOIBoloProducer);
+  REGPROD(SSTStarFinder);
+  REGPROD(TSidProducer);
+  REGPROD(GalCrossLocator);
+  REGPROD(StarMatcher);
+}
+
+
+
Index: trunk/Poubelle/archTOI.old/toimanager.h
===================================================================
--- trunk/Poubelle/archTOI.old/toimanager.h	(revision 534)
+++ trunk/Poubelle/archTOI.old/toimanager.h	(revision 534)
@@ -0,0 +1,39 @@
+// toimanager.h
+// Eric Aubourg         CEA/DAPNIA/SPP   septembre 1999
+
+#ifndef TOIMANAGER_H
+#define TOIMANAGER_H
+
+#include <set>
+#include <map>
+#include <iostream.h>
+using namespace std;
+
+#include "toi.h"
+
+class TOIProducer;
+class TOILowLevProducer;
+class TOIAbsorber;
+
+class TOIManager {
+public:
+  static void registerDefaultProducers();
+  static void registerProducer(TOIProducer* p);
+  static TOIProducer* findTOIProducer(TOI const& toi); // NULL if cannot build
+  
+  static set<TOIProducer*> producers;
+  
+  static void registerLLProducer(TOILowLevProducer* p, int blk_kind);
+  static void activateLLProducer(TOILowLevProducer* p);
+  static map<TOILowLevProducer*, long> llProducers; // long : masque de bloc
+  static map<TOILowLevProducer*, long> activeLLProducers; // long : masque de bloc
+  static int trigMask;
+  
+  static void dumpAvailTOIs(ostream& s);
+};
+
+#define REGPROD(_x_) TOIManager::registerProducer(new _x_);
+#define REGLLPROD(_x_,_blk_)  TOIManager::registerLLProducer(new _x_, _blk_);
+
+
+#endif
Index: trunk/Poubelle/archTOI.old/toiproducer.cc
===================================================================
--- trunk/Poubelle/archTOI.old/toiproducer.cc	(revision 534)
+++ trunk/Poubelle/archTOI.old/toiproducer.cc	(revision 534)
@@ -0,0 +1,235 @@
+// toiproducer.cc
+// Eric Aubourg         CEA/DAPNIA/SPP   septembre 1999
+
+#include <iostream.h>
+
+#include "toiproducer.h"
+#include "toiabsorber.h"
+#include "toimanager.h"
+#include "archexc.h"
+#include "requesthandler.h"
+
+void TOIProducer::outManifest(RequestHandler* h) {
+  outVersion(h);
+  h->processOption("#COMMENT", " Producing:");
+  for (set<TOI>::iterator i = producedTOIs.begin(); i != producedTOIs.end(); i++) {
+    h->processOption("#COMMENT", "  " + (*i).fullName());
+  }
+}
+
+void TOIProducer::outVersion(RequestHandler* h) {
+  h->processOption("#COMMENT", getName());
+}
+
+string TOIProducer::getName() {
+  return("Anonymous");
+}
+
+
+bool TOIProducer::canProduce(TOI const& toi) {
+  // It should be in our list of possibleTOI's
+  TOI myTOI;
+  for (set<TOI>::const_iterator i = possibleTOIs.begin(); i != possibleTOIs.end(); i++) {
+    if ((toi.name == (*i).name) &&
+        (toi.index == (*i).index || (*i).index == TOI::all)) {
+      myTOI = (*i); 
+      break;
+    }
+  }
+  if (myTOI.name == "") return false; // not in list
+  
+  // Handle options
+  
+  set<string> extraopts = toi.options;
+
+  // should contain mandatory options
+  for (set<string>::iterator i = myTOI.reqOptions.begin(); 
+       i != myTOI.reqOptions.end(); i++) {
+    if (extraopts.find(*i) == extraopts.end()) return false;
+  }
+  
+  // remove local options
+  for (set<string>::iterator i = myTOI.options.begin();
+       i != myTOI.options.end(); i++) {
+    extraopts.erase(*i);   
+  }
+  
+  // should be nothing left
+  if (!extraopts.empty()) return false;
+  
+  return true;
+}
+
+void TOIProducer::addTOI(TOI& toi, TOIAbsorber* client) {
+  if (!canProduce(toi)) throw ArchExc("Cannot produce " + toi.name);
+  // Add unit...
+  for (set<TOI>::const_iterator i = possibleTOIs.begin(); i != possibleTOIs.end(); i++) {
+    if (toi.name == (*i).name) {
+      toi.unit = (*i).unit; 
+      break;
+    }
+  }
+  
+  clients[client].insert(toi);
+  lastNeededSample[toi.ref][client] = 0;
+  producedTOIs.insert(toi);
+}
+
+bool TOIProducer::isProducing(TOI const& toi) {
+  return (producedTOIs.find(toi) != producedTOIs.end());
+}
+
+
+long TOIProducer::wontNeedEarlier(TOI const& toi, TOIAbsorber* client, long t) {
+  CHKPROD
+  long oldT = lastNeededSample[toi.ref][client];
+  if (t<oldT) return -1;
+  lastNeededSample[toi.ref][client] = t;
+  map<TOIAbsorber*, long> m = lastNeededSample[toi.ref];
+  long min=999999999L;
+  for (map<TOIAbsorber*, long>::iterator i = m.begin(); i != m.end(); i++) {
+    if ((*i).second < min) min = (*i).second;
+  }
+  deque<pair<long, double> >& h = history[toi.ref];
+  while(!h.empty() && h.front().first < min) h.pop_front();
+  return min;
+}
+
+set<string> TOIProducer::getProperAvailOptions(TOI const& toi) {
+//  toi.options.clear();
+//  toi.index = -2;
+//  set<TOI>::const_iterator i = possibleTOIs.upper_bound(toi);
+//  if ((*i).name != toi.name) throw ArchExc("no such toi " + toi.name);
+  for (set<TOI>::const_iterator i = possibleTOIs.begin(); i != possibleTOIs.end(); i++)
+    if ((*i).name  == toi.name)
+      return (*i).options;
+  throw ArchExc("no such toi " + toi.name);
+}
+
+set<string> TOIProducer::getAvailOptions(TOI const& toi) {
+  return getProperAvailOptions(toi);
+}
+
+
+  
+long TOIProducer::firstSampleNum(TOI const& toi) {
+  CHKPROD
+//  deque<pair<long, double> > h = (*history.find(toi)).second;
+  deque<pair<long, double> >& h = history[toi.ref];
+  if (h.empty()) return 99999999;
+  return h.front().first;
+}
+
+long TOIProducer::lastSampleNum(TOI const& toi) {
+  CHKPROD
+  deque<pair<long, double> >& h = history[toi.ref];
+  if (h.empty()) return -99999999;
+  return h.back().first;
+}
+
+class comp2nd { public:bool operator()(pair<long, double> const& a, long b) {return a.first<b;}};
+
+deque<pair<long, double> >::const_iterator TOIProducer::findHist(TOI const& toi,long sampleNum) {
+  CHKPROD
+  deque<pair<long, double> >& h = history[toi.ref];
+  return lower_bound(h.begin(), h.end(), sampleNum, comp2nd());
+}
+
+deque<pair<long, double> >::const_iterator TOIProducer::findHist(deque<pair<long, double> >& h,long sampleNum) {
+  return lower_bound(h.begin(), h.end(), sampleNum, comp2nd());
+}
+
+bool TOIProducer::canGetValue(long sampleNum, TOI const& toi) {
+  CHKPROD
+  deque<pair<long, double> >& h = history[toi.ref];
+  if (h.empty()) return false;
+  if (sampleNum < h.front().first || sampleNum > h.back().first) return false;
+  deque<pair<long, double> >::const_iterator i = findHist(h, sampleNum);
+  if (i == h.end()) return false;
+  return ((*i).first == sampleNum);
+}
+
+bool TOIProducer::canGetValueLater(long sampleNum, TOI const& toi) {
+  CHKPROD
+  deque<pair<long, double> >& h = history[toi.ref];
+  if (h.empty()) return true;
+  int x = h.back().first;
+  return sampleNum > x;
+  return (sampleNum > h.back().first);
+}
+
+bool TOIProducer::canGetPrevValue(long sampleNum, TOI const& toi) {
+  CHKPROD
+  deque<pair<long, double> >& h = history[toi.ref];
+  if (h.empty()) return false;
+  return (sampleNum > h.back().first && sampleNum <= h.front().first);
+   // Must be inside, otherwise we don't know if it is prev or simply past
+}
+ 
+bool TOIProducer::canGetNextValue(long sampleNum, TOI const& toi) {
+  CHKPROD
+  deque<pair<long, double> >& h = history[toi.ref];
+  if (h.empty()) return false;
+  return (sampleNum >= h.back().first && sampleNum < h.front().first);
+}
+
+double TOIProducer::getValue(long sampleNum, TOI const& toi) {
+  deque<pair<long, double> >& h = history[toi.ref];
+//  cout << "request " << sampleNum << " history " 
+//       << h.front().first 
+//       << " " << h.back().first << endl;
+  deque<pair<long, double> >::const_iterator i = findHist(h, sampleNum);
+  if (i == h.end()) return -999999;
+//  cout << "found " << (*i).first << endl;
+  return ((*i).first == sampleNum) ? (*i).second : -999999;
+}
+
+// $CHECK$ check this carefully !!!!
+
+double TOIProducer::getPrevValue(long& sampleNum, TOI const& toi) {
+  deque<pair<long, double> >& h = history[toi.ref];
+  deque<pair<long, double> >::const_iterator i = findHist(h, sampleNum);
+  if (i == h.end()) return -999999;
+  if ((*i).first == sampleNum) {
+    if (i == history[toi.ref].begin()) {sampleNum = -99999 ;return -9999;}
+    i--;
+  }
+  sampleNum = (*i).first;
+  return (*i).second;
+}
+
+double TOIProducer::getNextValue(long& sampleNum, TOI const& toi) {
+  deque<pair<long, double> >& h = history[toi.ref];
+  deque<pair<long, double> >::const_iterator i = findHist(h, sampleNum);
+  if (i == h.end()) return -999999;
+  if ((*i).first == sampleNum) {
+    if (i == history[toi.ref].end()) {sampleNum = -99999 ;return -9999;}
+    i++;
+  }
+  sampleNum = (*i).first;
+  return (*i).second;
+}
+
+void TOIProducer::computedValue(TOI const& toi, long sampleNum, double value) {
+  map<int, deque<pair<long, double> > >::iterator i = history.find(toi.ref);
+  if (i == history.end()) throw ArchExc("computedValue : bad TOI " + toi.name);
+  deque<pair<long, double> >& h = (*i).second;
+  if (!h.empty() && sampleNum <= h.back().first)
+    throw ArchExc("computedValue : sampleNum not in sequence for " + toi.name);
+  h.push_back(pair<long,double>(sampleNum,value));
+  
+  for (map<TOIAbsorber*, set<TOI> >::iterator j = clients.begin(); j != clients.end(); j++) {
+    set<TOI>& tois = (*j).second;
+    if (tois.find(toi) != tois.end()) 
+      (*j).first->dataFeed(this, toi, sampleNum, value);
+  } 
+}
+
+
+
+
+
+void TOILowLevProducer::addTOI(TOI& toi, TOIAbsorber* client) {
+  TOIProducer::addTOI(toi, client);
+  TOIManager::activateLLProducer(this);
+}
Index: trunk/Poubelle/archTOI.old/toiproducer.h
===================================================================
--- trunk/Poubelle/archTOI.old/toiproducer.h	(revision 534)
+++ trunk/Poubelle/archTOI.old/toiproducer.h	(revision 534)
@@ -0,0 +1,77 @@
+// toiproducer.h
+// Eric Aubourg         CEA/DAPNIA/SPP   septembre 1999
+
+#ifndef TOIPRODUCER_H
+#define TOIPRODUCER_H
+
+#include <set>
+#include <map>
+#include <deque>
+
+using namespace std;
+
+#include "toi.h"
+#include "ark.h"
+
+class TOIAbsorber;
+class RequestHandler;
+
+class TOIProducer {
+public:
+  TOIProducer() {}
+  virtual ~TOIProducer() {}
+  
+  virtual bool   canProduce(TOI const&);
+  virtual bool   isProducing(TOI const&);
+  virtual void   addTOI(TOI &, TOIAbsorber* client);     // exception si pas productible
+  virtual bool   canGetValue(long sampleNum, TOI const& toi); // for this samplenum
+  virtual bool   canGetPrevValue(long sampleNum, TOI const& toi); 
+  virtual bool   canGetNextValue(long sampleNum, TOI const& toi); 
+  virtual bool   canGetValueLater(long sampleNum, TOI const& toi);  // Might, later but not now
+  
+  virtual double getPrevValue(long& sampleNum, TOI const& toi);
+  virtual double getNextValue(long& sampleNum, TOI const& toi);
+  virtual double getValue(long sampleNum, TOI const& toi);
+  
+  virtual long   firstSampleNum(TOI const&);
+  virtual long   lastSampleNum(TOI const&);
+  
+  virtual long   wontNeedEarlier(TOI const&, TOIAbsorber* client, long);
+  
+  virtual set<string> getAvailOptions(TOI const&);
+  virtual set<string> getProperAvailOptions(TOI const&);
+  
+  virtual void outManifest(RequestHandler*);
+  virtual void outVersion(RequestHandler*);
+  virtual string getName();
+  
+  set<TOI> getPossibleTOIs() {return possibleTOIs;}
+  
+  
+protected:
+  virtual void   computedValue(TOI const& toi, long sampleNum, double value);
+
+  set<TOI>                               possibleTOIs;
+  set<TOI>                               producedTOIs;
+  map<TOIAbsorber*, set<TOI> >           clients;
+  //map<TOI, map<TOIAbsorber*, long> >     lastNeededSample; 
+  //map<TOI, deque<pair<long, double> > >  history;
+  map<int, map<TOIAbsorber*, long> >     lastNeededSample; 
+  map<int, deque<pair<long, double> > >  history;
+  
+  deque<pair<long, double> >::const_iterator findHist(TOI const& toi, long sampleNum);
+  deque<pair<long, double> >::const_iterator findHist(deque<pair<long, double> >& h, long sampleNum);
+};
+
+class ArchFileSet;
+class TOILowLevProducer : public TOIProducer {
+public:
+  virtual void handleBlock(ArchFileSet*)=0; // push !
+  virtual void   addTOI(TOI &, TOIAbsorber* client);     // exception si pas productible
+};
+
+//#define CHKPROD if (!isProducing(toi)) throw ArchExc("Not producing " + toi.name);
+#define CHKPROD toi;
+
+
+#endif
Index: trunk/Poubelle/archTOI.old/toipullproducer.cc
===================================================================
--- trunk/Poubelle/archTOI.old/toipullproducer.cc	(revision 534)
+++ trunk/Poubelle/archTOI.old/toipullproducer.cc	(revision 534)
@@ -0,0 +1,72 @@
+// toipullproducer.cc
+// Eric Aubourg         CEA/DAPNIA/SPP   octobre 1999
+
+
+#include "toipullproducer.h"
+
+TOIPullProducer::TOIPullProducer() {
+  needBefore = needAfter = 0;
+}
+
+bool TOIPullProducer::canGetValue(long sampleNum, TOI const& toi) {
+  map<TOI, TOIProducer*> m = neededTOIs[toi];
+  for (map<TOI, TOIProducer*>::iterator i = m.begin(); i != m.end(); i++) {
+    if (!(*i).second->canGetValue(sampleNum-needBefore, (*i).first) ||
+        !(*i).second->canGetValue(sampleNum+needAfter, (*i).first)) return false;
+  }
+  return true;
+}
+
+bool TOIPullProducer::canGetPrevValue(long sampleNum, TOI const& toi) {
+  return canGetValue(sampleNum-1, toi);
+}
+ 
+bool TOIPullProducer::canGetNextValue(long sampleNum, TOI const& toi) {
+  return canGetValue(sampleNum+1, toi);
+}
+
+bool TOIPullProducer::canGetValueLater(long sampleNum, TOI const& toi) {
+  map<TOI, TOIProducer*> m = neededTOIs[toi];
+  for (map<TOI, TOIProducer*>::iterator i = m.begin(); i != m.end(); i++) {
+    if (!(*i).second->canGetValueLater(sampleNum+needAfter, (*i).first)) return false;
+  }
+  return true;
+}
+
+
+double TOIPullProducer::getPrevValue(long& sampleNum, TOI const& toi) {
+  return getValue(--sampleNum, toi);
+}
+
+double TOIPullProducer::getNextValue(long& sampleNum, TOI const& toi) {
+  return getValue(++sampleNum, toi);
+}
+
+
+long TOIPullProducer::firstSampleNum(TOI const& toi) {
+  long xx = -999999999L;
+  map<TOI, TOIProducer*> m = neededTOIs[toi];
+  for (map<TOI, TOIProducer*>::iterator i = m.begin(); i != m.end(); i++) {
+    long x = (*i).second->firstSampleNum((*i).first) + needBefore;
+    if (x > xx) xx=x;
+  }
+  return xx;
+}
+
+long TOIPullProducer::lastSampleNum(TOI const& toi) {
+  long xx = 999999999L;
+  map<TOI, TOIProducer*> m = neededTOIs[toi];
+  for (map<TOI, TOIProducer*>::iterator i = m.begin(); i != m.end(); i++) {
+    long x = (*i).second->lastSampleNum((*i).first) - needAfter;
+    if (x < xx) xx=x;
+  }
+  return xx;
+}
+
+void TOIPullProducer::propagateLowBound(TOI const& toi, long sampleNum) {
+  CHKPROD
+  map<TOI, TOIProducer*> need = neededTOIs[toi];
+  for (map<TOI, TOIProducer*>::iterator i = need.begin(); i != need.end(); i++) {
+    (*i).second->wontNeedEarlier((*i).first, this, sampleNum-needBefore);
+  }
+}
Index: trunk/Poubelle/archTOI.old/toipullproducer.h
===================================================================
--- trunk/Poubelle/archTOI.old/toipullproducer.h	(revision 534)
+++ trunk/Poubelle/archTOI.old/toipullproducer.h	(revision 534)
@@ -0,0 +1,33 @@
+// toipullproducer.h
+// Eric Aubourg         CEA/DAPNIA/SPP   octobre 1999
+
+#ifndef TOIPULLPRODUCER_H
+#define TOIPULLPRODUCER_H
+
+#include "toiderivproducer.h"
+
+class TOIPullProducer : public TOIDerivProducer {
+public:
+  TOIPullProducer();
+  virtual bool   canGetValue(long sampleNum, TOI const& toi); // for this samplenum
+  virtual bool   canGetPrevValue(long sampleNum, TOI const& toi); 
+  virtual bool   canGetNextValue(long sampleNum, TOI const& toi); 
+  virtual bool   canGetValueLater(long sampleNum, TOI const& toi);  // Might, later but not now
+
+  virtual double getPrevValue(long& sampleNum, TOI const& toi);
+  virtual double getNextValue(long& sampleNum, TOI const& toi);
+  virtual double getValue(long sampleNum, TOI const& toi) = 0;
+
+  virtual long   firstSampleNum(TOI const&);
+  virtual long   lastSampleNum(TOI const&);
+
+protected:
+  long needBefore;
+  long needAfter;
+
+  virtual void         propagateLowBound(TOI const&, long sampleNum);
+};
+
+
+
+#endif
Index: trunk/Poubelle/archTOI.old/toisvr.cc
===================================================================
--- trunk/Poubelle/archTOI.old/toisvr.cc	(revision 533)
+++ trunk/Poubelle/archTOI.old/toisvr.cc	(revision 534)
@@ -162,38 +162,4 @@
     else tsttoi(alphaBolo)
     else tsttoi(deltaBolo)
-    else tsttoi(voyantEVO)
-    else tsttoi(voyantEVF)
-    else tsttoi(commandeEV0)
-    else tsttoi(commandeEVF)
-    else tsttoi(commandeEVB)
-    else tsttoi(commandeEVV)
-    else tsttoi(pressEnt3He)
-    else tsttoi(debit3He)
-    else tsttoi(pressSor3He)
-    else tsttoi(pressEnt4He)
-    else tsttoi(debit4He)
-    else tsttoi(pressSor4He)
-    else tsttoi(pressAirVanne)
-    else tsttoi(pressPompChar)
-    else tsttoi(pressMembrane)
-    else tsttoi(pressExterne)
-    else tsttoi(tensPile10T)
-    else tsttoi(tensPileP18D)
-    else tsttoi(tensPileM18D)
-    else tsttoi(tensPile10B)
-    else tsttoi(tensPileP18B)
-    else tsttoi(tensPileM18B)
-    else tsttoi(tensPileCh)
-    else tsttoi(swPile5)
-    else tsttoi(swPile15)
-    else tsttoi(tempCaissH1)
-    else tsttoi(tempCaissH2)
-    else tsttoi(tempCaissB1)
-    else tsttoi(tempCaissB2)
-    else tsttoi(tempCaissTHe)
-    else tsttoi(tempCaissPiles)
-    else tsttoi(tempCaissDrv)
-    else tsttoi(pressHeBain)
-    else tsttoi(pressPirani)
     else {
       // cerr << "*Warning, unrecognized TOI " << line << endl;
